diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
index 0f8529fca..02e94bb74 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.current.wire;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.core.block.BlockLogicConduit;
 import net.minecraft.core.block.BlockLogicWireRedstone;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.current.util.BlockState;
@@ -8,8 +9,12 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
+import static net.minecraft.core.current.wire.WireNode.Medium.CONDUIT;
+import static net.minecraft.core.current.wire.WireNode.Medium.DUST;
+
 /**
  * A WireNode is a Node that represents a wire in the world. It stores all the
  * information about the wire that the WireHandler needs to calculate power
@@ -20,6 +25,15 @@ import org.slf4j.Logger;
 public class WireNode extends Node {
     private static final Logger LOGGER = LogUtils.getLogger();
 
+    /** Which kind of power-carrying block this node represents. */
+    public enum Medium {DUST, CONDUIT}
+
+    final Medium medium;
+    /**
+     * The highest power level this node can actually store.
+     */
+    final int powerCeiling;
+
     final WireConnectionManager connections;
 
     /** The power level this wire currently holds in the world. */
@@ -49,21 +63,31 @@ public class WireNode extends Node {
     /** The next wire in the simple queue. */
     WireNode next_wire;
 
-    WireNode(World world, TilePosc pos, BlockState state) {
+    WireNode(World world, TilePosc pos, @NotNull BlockState state) {
         super(world);
 
         this.pos = new TilePos(pos);
         this.state = state;
 
-        this.connections = new WireConnectionManager(this);
+        this.medium = state.is(Blocks.CONDUIT) ? CONDUIT : DUST;
+
+        if (is(CONDUIT)) {
+            int data = state.get();
+            this.powerCeiling = BlockLogicConduit.isCap(data) ? 1 : BlockLogicWireRedstone.SIGNAL_MAX;
+            this.virtualPower = this.currentPower = BlockLogicConduit.getPower(data);
+            this.direction = 0;
+        } else {
+            this.powerCeiling = BlockLogicWireRedstone.SIGNAL_MAX;
+            this.virtualPower = this.currentPower = this.state.get() & BlockLogicWireRedstone.MASK_POWER;
+            this.direction = this.state.get() & BlockLogicWireRedstone.MASK_DIRECTION;
+        }
 
-        this.virtualPower = this.currentPower = this.state.get() & BlockLogicWireRedstone.MASK_POWER;
-        this.direction = this.state.get() & BlockLogicWireRedstone.MASK_DIRECTION;
+        this.connections = new WireConnectionManager(this);
         this.priority = priority();
     }
 
     @Override
-    Node set(TilePosc pos, BlockState state, boolean clearNeighbors) {
+    Node set(TilePosc pos, @NotNull BlockState state, boolean clearNeighbors) {
         throw new UnsupportedOperationException("Cannot update a WireNode!");
     }
 
@@ -82,17 +106,30 @@ public class WireNode extends Node {
         return this;
     }
 
-    boolean offerPower(int power, int iDir) {
+    //leave non-inline for future proofing (any other mediums added)
+    boolean is(Medium medium) {
+        return this.medium == medium;
+    }
+
+    /** Clamp a power level to what this node is actually able to hold. */
+    int clampPower(int power) {
+        return Math.min(power, this.powerCeiling);
+    }
+
+    boolean offerPower(int power, int iDir, boolean recordFlow) {
         if (this.removed || this.shouldBreak) {
             return false;
         }
+
         if (power == this.virtualPower) {
-            this.flowIn |= (1 << iDir);
+            if (recordFlow) {
+                this.flowIn |= (1 << iDir);
+            }
             return false;
         }
         if (power > this.virtualPower) {
             this.virtualPower = power;
-            this.flowIn = (1 << iDir);
+            this.flowIn = recordFlow ? (1 << iDir) : 0;
 
             return true;
         }
@@ -107,9 +144,23 @@ public class WireNode extends Node {
 
         this.state = WorldHelper.getBlockState(this.world, this.pos);
 
+        if (is(CONDUIT)) {
+            if (!this.state.is(Blocks.CONDUIT)) {
+                LOGGER.warn("Tried to update power of a conduit that is no longer there! This should never happen!", new RuntimeException());
+                return false; // we should never get here
+            }
+
+            int oldData = this.state.get();
+            int newData = BlockLogicConduit.withPower(oldData, MathHelper.clamp(this.virtualPower, BlockLogicWireRedstone.SIGNAL_MIN, BlockLogicWireRedstone.SIGNAL_MAX));
+            this.currentPower = BlockLogicConduit.getPower(newData);
+            this.state = this.state.set(newData);
+
+            return WorldHelper.setWireState(this.world, this.pos, this.state);
+        }
+
         if (!this.state.is(Blocks.WIRE_REDSTONE)) {
             LOGGER.warn("Tried to update power of non redstone dust! This should never happen!", new RuntimeException());
-            return false; // we should never get here
+            return false; // we should also never get here
         }
 
         if (this.shouldBreak) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index d23c84461..06ce3d305 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -109,6 +109,11 @@ public abstract class Entity
     public int pushesThisTick;
     public int acidJumpCooldown = 0;
 
+    // When true, move() writes the moved bounding box back into x/y/z even for a client-side Mob.
+    // Used while a client locally simulates a vehicle it is driving so position-derived
+    // logic like limbs, etc. tracks the real movement instead of staying frozen.
+    public boolean locallySimulated = false;
+
     // Vehicle
     public @Nullable IVehicle vehicle;
     private double entityRiderPitchDelta;
@@ -167,6 +172,7 @@ public abstract class Entity
 
     // Data
     public boolean sendAdditionalData = false;
+    public boolean additionalDataChanged = false;
     protected final @NotNull SynchedEntityData entityData = new SynchedEntityData();
 
     public Entity(final @NotNull World world) {
@@ -606,7 +612,7 @@ public abstract class Entity
             }
         }
         //fix for entity jitter when blasted by cannonballs (can cause some client-side jitter when entity is under a ceiling. unsure exactly why)
-        if (!this.world.isClientSide || this instanceof Player || !(this instanceof Mob)) {
+        if (!this.world.isClientSide || this instanceof Player || !(this instanceof Mob) || this.locallySimulated) {
             this.x = (this.bb.minX + this.bb.maxX) / 2D;
             this.y = (this.bb.minY + (double) this.heightOffset) - (double) this.ySlideOffset;
             this.z = (this.bb.minZ + this.bb.maxZ) / 2D;
@@ -1144,6 +1150,10 @@ public abstract class Entity
         return isPickable();
     }
 
+    public boolean passesThroughRiderTargeting(@Nullable ItemStack heldItem) {
+        return false;
+    }
+
     public boolean isPushable() {
         return false;
     }
@@ -1193,6 +1203,8 @@ public abstract class Entity
         tag.putShort("Air", (short) this.airSupply);
         tag.putBoolean("OnGround", this.onGround);
         tag.putFloat("PushTime", this.pushTime);
+        //MC-2025 fix by @theosib and @Kademlia. Persists the exact bounding box so it can be restored on load instead of being recomputed from position.
+        tag.put("AABB", newDoubleList(new double[]{this.bb.minX, this.bb.minY, this.bb.minZ, this.bb.maxX, this.bb.maxY, this.bb.maxZ}));
         addAdditionalSaveData(tag);
     }
 
@@ -1226,6 +1238,10 @@ public abstract class Entity
         setPos(this.x, this.y, this.z);
         setRot(this.yRot, this.xRot);
         readAdditionalSaveData(tag);
+        if (tag.containsKey("AABB")) {ListTag aabbTag = tag.getList("AABB");
+            this.bb.setMin(((DoubleTag) aabbTag.tagAt(0)).getValue(), ((DoubleTag) aabbTag.tagAt(1)).getValue(), ((DoubleTag) aabbTag.tagAt(2)).getValue());
+            this.bb.setMax(((DoubleTag) aabbTag.tagAt(3)).getValue(), ((DoubleTag) aabbTag.tagAt(4)).getValue(), ((DoubleTag) aabbTag.tagAt(5)).getValue());
+        }
     }
 
     public final @Nullable NamespaceID getDispatcherId() {
@@ -1585,12 +1601,14 @@ public abstract class Entity
         return true;
     }
 
-    public void handleSpecialVehicleControl() {
+    public void handleSpecialVehicleControl() {}
 
-    }
+    public void sendSpecialVehiclePacket() {}
 
-    public void sendSpecialVehiclePacket() {
+    public void handleControlDirect(double xd, double yd, double zd, float yRot) {}
 
+    public boolean relaysVehicleControl() {
+        return false;
     }
 
     public boolean deferVehicleBehavior() {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
index 3de7f1161..22b02aef4 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
@@ -177,9 +177,7 @@ public class EntityFishingBobber extends Entity {
                     double distance = MathHelper.sqrt(dx * dx + dy * dy + dz * dz);
                     if (distance > 10) {
                         double scale = 0.01D;
-                        this.hookedEntity.xd += dx * scale;
-                        this.hookedEntity.yd += dy * scale;
-                        this.hookedEntity.zd += dz * scale;
+                        this.hookedEntity.fling(dx * scale, dy * scale, dz * scale, 0f);
                     }
                     return;
                 }
@@ -374,9 +372,7 @@ public class EntityFishingBobber extends Entity {
             double dz = this.owner.z - this.z;
             double distance = MathHelper.sqrt(dx * dx + dy * dy + dz * dz);
             double scale = 0.1D;
-            this.hookedEntity.xd += dx * scale;
-            this.hookedEntity.yd += dy * scale + (double) MathHelper.sqrt(distance) * 0.08D;
-            this.hookedEntity.zd += dz * scale;
+            this.hookedEntity.fling(dx * scale, dy * scale + (double) MathHelper.sqrt(distance) * 0.08D, dz * scale, 0f);
             damage = 3;
         } else if (this.ticksCatchable > 0) {
             if (!this.world.isClientSide) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
index 67cee9925..9f1ca5610 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -4,6 +4,7 @@ import java.util.List;
 import java.util.Objects;
 
 import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.Global;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
@@ -20,6 +21,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
@@ -38,6 +40,33 @@ public class EntityItem extends Entity
     public float bobOffset;
     public int basketPickupDelay = 0;
     public static boolean enableItemClumping = true;
+    private static final int BASE_DESPAWN_TICKS = 10 * 60 * 20;
+    private static final int BASE_FADE_TICKS = 2 * 60 * 20;
+    public static final float DESPAWN_ALPHA_THRESHOLD = 0.01f;
+    private static final int DESPAWN_FORCE_REMOVE_BUFFER = 20;
+
+    public static int getDespawnFadeTicks(final int lifetime) {
+        if (lifetime <= 0) {
+            return 0;
+        }
+        return Math.max(1, lifetime * BASE_FADE_TICKS / BASE_DESPAWN_TICKS);
+    }
+
+    public static float getDespawnFadeAlpha(final int age, final int lifetime, final float partialTick) {
+        if (lifetime < 0) {
+            return 1.0f;
+        }
+        final float adjustedAge = age + partialTick;
+        final int fadeWindow = getDespawnFadeTicks(lifetime);
+        final float fadeStart = lifetime - fadeWindow;
+        if (adjustedAge <= fadeStart) {
+            return 1.0f;
+        }
+        final float elapsed = adjustedAge - fadeStart;
+        final float toDeath = 1.0f - elapsed / fadeWindow;
+        final double period = 6.8 + 1.2 * toDeath;
+        return (float) (0.5 + 0.5 * Math.cos((elapsed * Math.PI) / period));
+    }
 
     public EntityItem(@NotNull World world, double x, double y, double z, @NotNull ItemStack itemstack) {
         super(world);
@@ -131,9 +160,13 @@ public class EntityItem extends Entity
         }
 
         this.age++;
-        if(this.age >= this.lifetime && this.lifetime >= 0 && !this.item.getItem().hasTag(ItemTags.IS_PERSISTENT)) // Negative lifetime indicates items should last forever
-        {
-            remove();
+        if (this.lifetime >= 0 && !this.item.getItem().hasTag(ItemTags.IS_PERSISTENT)) {
+            if (this.age >= this.lifetime) {
+                if (getDespawnFadeAlpha(this.age, this.lifetime, 0f) <= DESPAWN_ALPHA_THRESHOLD
+                    || this.age >= this.lifetime + DESPAWN_FORCE_REMOVE_BUFFER) {
+                    remove();
+                }
+            }
         }
     }
 
@@ -207,6 +240,9 @@ public class EntityItem extends Entity
 			player.inventory.insertItem(this.item, true);
 
 			if(this.item.stackSize < previousStackSize) {
+				if(this.item.stackSize > 0) {
+					this.additionalDataChanged = true;
+				}
 				if(this.item.itemID < 16384) {
                     Block<?> b = Blocks.blocksList[this.item.itemID];
 					if(b != null && b.getLogic() instanceof BlockLogicLog) {
@@ -369,7 +405,7 @@ public class EntityItem extends Entity
                 this.yd += 0.001;
             }
 
-            if(blockUnderItem == Blocks.MESH)
+            if(blockUnderItem == Blocks.MESH || blockUnderItem == Blocks.SPIKES)
             {
                 this.yd -= 0.02D;
             }
@@ -383,6 +419,7 @@ public class EntityItem extends Entity
                     }
                 }
             }
+            this.yd -= 0.02D;
         }
         //gravity out of water
         else
@@ -410,12 +447,34 @@ public class EntityItem extends Entity
     public boolean isBeingSiphoned(){
         return siphonDirection != Direction.NONE;
     }
-    
+
+    @Override
+    public byte calcLightIndex(float partialTick) {
+        if (Global.accessor.isFullbrightEnabled()) return LightIndexHelper.lightIndex2i(15, 15);
+        TilePos blockPos = new TilePos(this.x, this.y - this.heightOffset + this.ySlideOffset + this.bbHeight * 0.66D, this.z);
+
+        byte lightIndex = 0;
+        if (this.world.getBlockLitInteriorSurface(blockPos) || this.world.getBlockType(blockPos).isSolidRender()) {
+            TilePos queryPos = new TilePos();
+
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.up(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.west(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.east(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.south(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.north(queryPos)));
+        } else {
+            lightIndex = this.world.getSavedLightIndex(blockPos);
+        }
+
+        return lightIndex;
+    }
+
     private static void combineItems(EntityItem entityItem1, EntityItem entityItem2) {
     	entityItem1.item.stackSize += entityItem2.item.stackSize;
     	entityItem2.item.stackSize = 0;
     	entityItem1.age = Math.min(entityItem1.age, entityItem2.age);
     	entityItem1.pickupDelay = Math.max(entityItem1.pickupDelay, entityItem2.pickupDelay);
+    	entityItem1.additionalDataChanged = true;
     	entityItem2.remove();
     }
 }
